package {
	
	import com.greensock.easing.Cubic;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Vector3D;
	import com.greensock.TweenMax;
	public class Bit extends Sprite {
		
		private var _right:Bit;
		private var _left:Bit;
		
		public var light:Sprite;
		public var dark:Sprite;
		public var lightPoint:Point = new Point();
		public var darkPoint:Point = new Point();
		public var rd:Number = (180 / Math.PI);
		public var degree:int = 0;
		public static var spinSpeed:Number = 0;
		public var distance:int = 40;
		public var line:Sprite;
		public var swapped:Boolean = false;
		public var shouldSwap:Boolean = true;
		public var swapping:Boolean = false;
		public var mul:Number = 1;
		
		public function Bit()  {
			super();
			line = new Sprite();
			addChild(line);
			line.scaleX = line.scaleY = .5;
			light = UtilsArt.makeCircle(10, 0xbbbbbb);
			dark = UtilsArt.makeCircle(10, 0x444444);
			addChild(light);
			addChild(dark);
			Scheduler.invokeEvery(update);
		}
		
		public function update():void {
			degree += spinSpeed;
			lightPoint.y = Math.sin(degree/rd)*distance*mul;
			lightPoint.x = Math.cos(degree/rd) * distance*mul;
			darkPoint.y = Math.sin((degree+180)/rd)*distance*mul;
			darkPoint.x = Math.cos((degree + 180) / rd) * distance*mul;
			
			light.y = lightPoint.y;
			light.z = lightPoint.x;
			dark.y = darkPoint.y;
			dark.z = darkPoint.x;
			setChildIndex(dark.z > light.z?dark:light, 1);
			drawLine();
		}
		
		public function drawLine():void {
			var pL:Point = light.local3DToGlobal(new Vector3D(light.x, light.y, light.z));
			var pD:Point = dark.local3DToGlobal(new Vector3D(dark.x, dark.y, dark.z));
			line.graphics.clear();
			var c:uint = 0x000000;
			var randomize:int = 0;
			var thick:int = 12;
			if (left && !left.correct) {
				c = 0xcccccc;				
				randomize += 3;
				thick = 4;
			}
			if (right && !right.correct) {
				c = 0xcccccc;	
				randomize *= 2;
				randomize += 3;
				thick = 4;
			}
			line.x = Math.random()*randomize - randomize*.5
			line.graphics.lineStyle(thick, c);
			line.graphics.moveTo((pL.x-this.x), pL.y-this.y);
			line.graphics.lineTo((pD.x - this.x), pD.y - this.y);
		}

		public function swap():void {
			swapped = !swapped;
			swapping = true;
			TweenMax.to(this, .5, { mul:mul * -1, onComplete:stopSwap } );
		}
		public function stopSwap():void {
			swapping = false;
		}
		
		public function get left():Bit {return _left;}	
		public function set left(value:Bit):void {
			_left = value;
			_left._right = this;
		}
		
		public function get right():Bit {return _right;}	
		public function set right(value:Bit):void {
			_right = value;
			_right._left = this;
		}
		
		public function get correct():Boolean {
			return swapped == shouldSwap;
		}
		
		public function cleanup():void {
			Scheduler.cancel(update);
			Utils.removeChild(this);
		}
		
		public function deselect():void {
			TweenMax.to(this, 1, {distance:40, ease: Cubic.easeOut } );
			
		}
		public function select():void {
			TweenMax.to(this, 1, { distance:100, ease: Cubic.easeOut } );		
		}
	}
}