package {
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author netgrind
	 */
	public class Split extends Level {
		private var newFollow:Boolean = false;
		private var splitter:Sprite;
		private var lastMouse:Point = new Point();
		
		public var balls:Vector.<Ball> = new Vector.<Ball>;
		public var all:Sprite = new Sprite();
		public var meta:Bitmap = new Bitmap(new BitmapData(800, 600));
		public var bd:BitmapData;
		public var ballSize:int = 50;
		public var ballDistance:int = 120;
		
		public function Split() {
			super();
			balls.push(new Ball());
			balls.push(new Ball);
			all.addChild(balls[1]);
			all.addChild(balls[0]);
			balls[0].scaleX = balls[0].scaleY = 0;
			balls[0].x = balls[1].x = 400;
			balls[0].y = balls[1].y = 300;
			splitter = balls[1];
			UtilsArt
			all.filters = [new BlurFilter(50, 50)];
			
			addChild(meta);
			bd = meta.bitmapData;
			Scheduler.invokeEvery(update);
		}
		
		public function addBallAtMouse():void {
			var s:Ball = new Ball();
			s.x = mouseX;
			s.y = mouseY;
			all.addChild(s);
			balls.push(s);
		}
		
		public function update():void {
			var mouse:Point = new Point(mouseX, mouseY);
			if (!newFollow ) {
				TweenMax.to(balls[0], 2, { x:splitter.x, y:splitter.y, scaleX:.1, scaleY:.1 } );
				if(Point.distance(Utils.makePoint(splitter), mouse) < 40) {
					newFollow = true;
				}
			}
			if (newFollow) {
				if (Point.distance(mouse, lastMouse) >ballSize*.25) {
					TweenMax.to(balls[0], 2, { x:splitter.x, y:splitter.y, scaleX:.1, scaleY:.1 } );
					newFollow = false;
				}else{
					TweenMax.to(balls[0], 1, { x:mouseX, y:mouseY } );
					var dist:int = Point.distance(Utils.makePoint(balls[0]), Utils.makePoint(splitter));
					balls[0].scaleX = balls[0].scaleY = Math.min(1, dist / 100);
					if (dist > ballDistance) {
						splitComplete();
					}
				}
			}
			
			for (var i:int = 0; i < balls.length; i++) {
				for (var j:int = i; j < balls.length; j++) {
					//CLEAN THIS FILTHY IF LATER, MOVE SHIT DOWN TO INDIVIDUAL MOVEMENT TODO CALE
					if (i != j && (!newFollow || balls[i]!=splitter) && (!newFollow || balls[j]!=splitter)&& (!(i==0&&balls[j]==splitter)&&!(j==0&&balls[i]==splitter))) {
						var distanceBetween:int = Point.distance(Utils.makePoint(balls[i]), Utils.makePoint(balls[j]));
						if (distanceBetween < ballDistance*((i==0||j==0)?balls[0].scaleX+.1:1)) {
							var angle:Number = Utils.degToRad(Utils.getAngle(balls[i].x, balls[i].y, balls[j].x, balls[j].y));
							
							balls[j].accel.y+=(Math.sin(angle));
							balls[j].accel.x += (Math.cos(angle));
							balls[i].accel.y-=(Math.sin(angle));
							balls[i].accel.x-=(Math.cos(angle));
						}
					}
				}
				if(i!=0){;
					balls[i].x += balls[i].accel.x;
					balls[i].y += balls[i].accel.y;
					balls[i].accel.x *= .8;
					balls[i].accel.y *= .8;
					if (balls[i].accel.x < .01 && balls[i].accel.x>.01) {
						balls[i].accel.x  = 0
					}
					if (balls[i].accel.y < .01 && balls[i].accel.y>.01) {
						balls[i].accel.y  = 0
					}
				}
				while(Point.distance(Utils.makePoint(balls[i]), new Point(400, 300)) > 260) {
					var a:Number = Utils.getAngle(balls[i].x, balls[i].y, 400,300);
					if (a < 135 && a >= 45) {
						balls[i].y++;
					}else if (a < 45 && a >= -45) {
						balls[i].x++;
					}else if (a < -45 && a >= -135) {
						balls[i].y--;
					}else {
						balls[i].x--;
					}
				}
			}
			
			lastMouse = mouse;
			draw();
		}
		
		public function splitComplete():void {
			var s:Ball = new Ball();
			s.accel.x = (mouseX - lastMouse.x)*2;
			s.accel.y = (mouseY - lastMouse.y)*2;
			s.x = balls[0].x;
			s.y = balls[0].y;
			all.addChild(s);
			balls.push(s);
			balls[0].scaleX = balls[0].scaleY = .1;
			splitter = balls[Math.floor(Math.random()*(balls.length-2))+1]
			balls[0].x = splitter.x;
			balls[0].y = splitter.y;
			TweenLite.killTweensOf(balls[0]);
			newFollow = false;
			if (balls.length == 9) {
				endLevel();
			}
		}
		
		public function draw():void {
			var temp:BitmapData = new BitmapData(800, 600, true, 0);
			temp.draw(all);
			bd.fillRect(bd.rect, 0xffffffff);
			bd.threshold(temp, temp.rect, new Point(), '>', 0xaaaaaaaa, 0xff444444);
			bd.threshold(temp, temp.rect, new Point(), '>', 0xcccccccc, 0xff222222);
			bd.threshold(temp, temp.rect, new Point(), '>', 0xeeeeeeee, 0xff000000);
		}
		
	}
	
}