package {
	import com.greensock.easing.Cubic;
	import com.greensock.TweenMax;
	import flash.display.Sprite;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author netgrind
	 */
	public class DNA extends Level {
		
		public var bits:Vector.<Bit> = new Vector.<Bit>;
		private var _selected:Bit;
		private var yDist:int;
		public var lastMouse:Point = new Point();
		public var solution:Array = [true,false,false,true,true,false,true,true,true,false,false,true]
		
		public function DNA() {
			for (var i:int = 0; i < 12; i++) {
				var b:Bit = new Bit();
				b.x = i * 60 + 60;
				b.y = 300;
				b.degree = i * 30;
				b.shouldSwap = solution[i];
				addChild(b);
				bits.push(b);
				if (i != 0) {
					b.left = bits[i-1]
				}
			}
			Scheduler.invokeEvery(update);
			super();
		}
		
		public function update():void {
			if (Math.abs(mouseX - lastMouse.x) > Math.abs(mouseY - lastMouse.y)) {
				yDist = 0;
				var tryNdx:int = (mouseX - 30) / 60;
				if (tryNdx >= 0 && tryNdx < bits.length) {
					selected = bits[tryNdx];
				}
			}else {
				if(selected && !selected.swapping){
					if ((lastMouse.y<300 && mouseY>300)||(lastMouse.y>300 && mouseY<300)) {
						selected.swap();
						yDist = 0;
					}
				}
			}
			var finished:Boolean = true;
			for (var i:int = 0; i < bits.length; i++) {
				TweenMax.to(bits[i],.5,{degree:i * 30 - ((mouseX - 30) / 2) + 90});
				if(finished){
					if (bits[i].swapping) {
						finished = false;
					}
					if (!bits[i].correct) {
						finished = false;
					}
				}
			}
			if (finished) {
				Scheduler.cancel(update);
				playWin();
			}
			lastMouse.x = mouseX;
			lastMouse.y = mouseY;
		}
		
		public function playWin():void {
			_selected.deselect();
			TweenMax.to(Bit, 3, { spinSpeed:5 } );
			Scheduler.invokeIn(endLevel, 130);
		}
		
		public function get selected():Bit {return _selected;}		
		public function set selected(value:Bit):void {
			if (_selected && _selected!=value) {
				_selected.deselect()
			}
			_selected = value;
			_selected.select();
		}
		
		override public function cleanup():void {
			for (var i:int = 0; i < bits.length; i++) {
				bits[i].cleanup();
			}
			Scheduler.cancel(update);
			Utils.removeChild(this);
			super.cleanup();
		}
	}	
}